<?php

/**
 * inf_tit_marca actions.
 *
 * @package    canon
 * @subpackage inf_tit_marca
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_tit_marcaActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */
            
            $whereTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $whereTitulo = " AND tab0.id_titulo = '" . $request['id_titulo'] . "' ";
            }
            
            $whereCompetencia = ' ';
            if (isset($request['id_competencia'])) {
                $whereCompetencia = " AND tab0.id_competencia = '" . $request['id_competencia'] . "' ";
            }
            
            $whereFechaRegistro = " and tit.fecha_inscripcion_rmn between "
            . "to_date( '" . $request["fecha_ini"] . "' , 'YYYY-MM-DD' ) and to_date( '" . $request["fecha_fin"] . "' , 'YYYY-MM-DD' ) ";
            
            $whereEstado = ' ';
            if (isset($request['estado'])) {
                if($request['estado']=="true")
                {
                    $whereEstado = ' AND tab0.estado = 1';
                }else{
                    $whereEstado = '';
                }
                
            }
            
            $sortBy="tab0.fecha_inscripcion_rmn";
            if (isset($request['_sortBy'])) {
                $sortBy=$request["_sortBy"];
            }
            

            $query="
select distinct tab0.* from (                
select tit.id_titulo, tit.cod_exp, to_char(tit.fecha_inscripcion_rmn, 'YYYY-MM-DD') as fecha_inscripcion_rmn,
to_char(tit.fecha_ter, 'YYYY-MM-DD') as fecha_ter,
nc.descripcion as desc_norma, m.nombre as desc_modalidad,
cmp.nombre as desc_competencia, ta.area as area_actual, 
cmp.id_competencia, to_char(tmar.fecha_marca, 'YYYY-MM-DD') as fecha_marca, tmar.observaciones as observaciones,
tmar.estado, tmar.id_titulo_marca, us.username
from rmn_titulo tit
join ca_titulo_etapa te on tit.id_titulo=te.id_titulo and te.actual=1
join in_titulo_competencia tc on tc.id_titulo = tit.id_titulo and tc.actual = 1
join rmn_competencia cmp on cmp.id_competencia = tc.id_competencia
join ca_titulo_norma tn on tn.id_titulo=tit.id_titulo and tn.actual=1
join ca_norma_canon nc on nc.id_norma = tn.id_norma
join rmn_titulo_modalidad tm on tm.id_titulo = tit.id_titulo and tm.actual=1
join rmn_modalidad m on m.id_modalidad = tm.id_modalidad
join in_titulo_area ta on ta.id_titulo=tit.id_titulo and ta.actual=1
left join ca_titulo_marca tmar on tmar.id_titulo = tit.id_titulo
left join ca_usuario us on us.id_usuario = tmar.id_usuario_marca
where 1=1 $whereFechaRegistro
and cmp.num_doc in ('8999992948', '8904800591', '8918004981', '8908010521', '8923999999', '8905014342', '9005000182')
)tab0
where 1=1
 $whereTitulo $whereCompetencia $whereEstado
order by $sortBy
";

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
$query      
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
$query     
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_titulo_marca');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[TITULO MARCA] Consulta exitosa.");
            } else {

                $mensaje = "[TITULO MARCA] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[TITULO MARCA] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}

